/* prog 3.7 Coin Flipping simulation */

#include <stdio.h>
#include <stdlib.h>

int heads(void); /* prototype */

int main(int argc, char *argv[])
{
	int i, j, cnt; /* loop vars & head count */
   int N, M, *f; /* # flips, run, & frequency of heads */
   char buf[BUFSIZ];

   if (argc == 3)
   { /* arguments specified on command line */
   	N = atoi(argv[1]);
      M = atoi(argv[2]);
   }
   else
   { /* ask user for values */
   	printf("How many flips? ");
      gets(buf);
      N = atoi(buf);
      printf("How many runs? ");
      gets(buf);
      M = atoi(buf);
   }

   /* allocate space for N entries in array */
   f = (int *)malloc((N+1)*sizeof(int));

   /*
    * The array entry f[n] records how many experiments
    * resulted in 'n' heads after N flips
    */
   /* initialize array to no heads */
   for (j = 0; j <= N; j++) f[j] = 0;

   /* now run simulation M times */
   for (i = 0; i < M; i++)
   {
   	/* flip coin N times & count heads */
   	for (cnt = 0, j = 0; j <= N; j++)
      {
        if (heads()) cnt++; /* increment count */
      }
      f[cnt]++; /* increment frequency count of heads */
   }
   for (j = 0; j <= N; j++)
   { /* graph each entry */
    	printf("%2d ", j); /* Y value */
      /* draw an asterix for every 10 runs */
      for (i = 0; i < f[j]; i+=10) printf("*");
      printf("\n");
   }
   printf("Press ENTER to terminate program: ");
   gets(buf);
 }
 
int heads(void)
{ /* randomly pick heads (1) or tails (0) */
	return rand() % 2;
}

