/* prog 3.9 - Josephus Problem */

#include <stdio.h>
#include <stdlib.h>

typedef struct node* link;

struct node {
 int item;
 link next;
};

main(int argc, char *argv[])
{
	int i, N, M;
   link t, x;
   char buf[BUFSIZ];

   if (argc == 3)
   { /* use command line arguments */
		N = atoi(argv[1]);
      M = atoi(argv[2]);
	}
   else
   { /* ask user for values */
   	printf("Enter number of nodes: ");
      gets(buf);
      N = atoi(buf);
      printf("Enter number to skip: ");
      gets(buf);
      M = atoi(buf);
   }

   /* allocate memory for head of list */
	t = (link)malloc(sizeof *t);
   x = t;

   /* set up head node */
   t->item = 1;	/* first entry */
   t->next = t;	/* single node (circular) list */

   /* generate list with N nodes */
    for (i = 2; i <= N; i++)
    {
    	/* create node & link it after current node */
    	x->next = (link)malloc(sizeof *x);
    	x = x->next; /* new "current" node */
      x->item = i;	/* item number */
      if (i == N) x->next = t;	/* link last node to front */
    }

    /* list created - now process it */
    while (x != x->next)
      { /* loop until only one node left */
      	/* skip 'M' nodes */
        for (i = 1; i < M; i++) x = x->next;
        /* this is node to delete */
        x->next = x->next->next;
        /* node deleted - reduce count of nodes */
        N--;
      }
      /* only one node left - print it */
    printf("%d\n", x->item);
    printf("Press ENTER to terminate program: ");
    gets(buf);
}

