/* prog 4.4 - Array Implementation of Stack */

#include <stdio.h>
#include <stdlib.h>
#include "stack.h"

#define STACKSIZE 100	/* default stack size */

static Item *s;	/* stack */
/* N is initialized to -1 for error checking */
static int N=-1;	/* size of stack */

void STACKinit(int maxN)
{
	s = (Item *)malloc(maxN*sizeof(Item));
   N = 0;
}

int STACKempty()
{
	return N <= 0;	/* true if stack is empty */
}
void STACKpush(Item item)
{
	/* if not initialized, then initialize it */
	if (N < 0) STACKinit(STACKSIZE);
	s[N++] = item;
}

Item STACKpop()
{
	if (N <= 0)
   {  /* error - stack underflow */
   	fprintf(stderr, "Stack Underflow!\n");
      return 0; /* have to return something */
   }
   /* N is location of next free entry */
   /* N-1 is location of top entry */
	return s[--N];	/* pop from stack */
}

