/* prog 4.5 - Linked-List Implementation of Stack */

#include <stdio.h>
#include <stdlib.h>

#include "stack.h"

/* linked list nodes */
typedef struct STACKnode* link;
struct STACKnode { Item item; link next; };

static link head = NULL; /* actual stack */

link NEW(Item item, link next)
{ /* constructor for link - also does a push */
	link x = (link)malloc(sizeof *x); /* allocate node */
   x->item = item; /* assign item value */
   x->next = next; /* point to rest of list */
   return x; /* return new head of list */
}

void STACKinit(int maxN)
{ /* only needed if stack is re-used */
	head = NULL;
}

int STACKempty()
{ /* boolean function to determine if stack is empty */
	return head == NULL; /* true if stack is empty */
}

void STACKpush(Item item)
{
	head = NEW(item, head); /* add new node to head */
}

Item STACKpop()
{
	Item item;	/* value to be popped */
   link t;	/* temp node */

	item = head->item;	/* get value on top of stack */
   t = head->next;	/* save loc of second node */
   free(head);	/* free top node */
   head = t;	/* former second node is now at head */
   return item;	/* return value */
}
