/* prog 5.11 - Fibonacci - dynamic programming */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAXNUM 100

int F1(int);
int F2(int);

int knownF[MAXNUM];
int unknown = 0;
int ncalls = 0;

int main()
{
	char buf[BUFSIZ];
   int num, ret, resetflg;
   time_t t1, t2, ta, tb;	/* time variables */

   printf("This program illustrates the advantage of dynamic programming\n");
   printf("Pick several different numbers to get a sense of how previous\n");
   printf("calculations speed response time.\n");
   printf("\nPick a number less than %d!\n", MAXNUM);

   printf("You can reset the table after each calculation\n");
   printf("or you can retain prior calculations between numbers.\n");
   printf("Retain values? (y or n): ");
   gets(buf);

   resetflg = *buf == 'y' || *buf == 'Y';

   while (1)
   {
   	printf("Enter number or ENTER to quit: ");
      gets(buf);
      if (*buf == '\0') break;
      /* clear known array each time for a better compare */
      if (resetflg)
      {
   		for (num=0; num < MAXNUM; num++) knownF[num] = unknown;
      }
      num = atoi(buf);
      if (num > MAXNUM)
      {
      	printf("Pick a number less than %d\n", MAXNUM);
         continue;
      }
      ncalls = 0;

      printf("The inefficient method ...\n");
      t1 = time(NULL);		/* start time */
      ret = F1(num);
      t2 = time(NULL);		/* end time - inefficient method */
      ta = t2 - t1;			/* time to solve */
      printf("\nF1(%d) is %d after %d calculations and %ld seconds\n",
      	num, ret, ncalls, ta);
      ncalls = 0;
		printf("Press ENTER for efficient method: ");
      gets(buf);
      t1 = time(NULL);
      ret = F2(num);
      t2 = time(NULL);
      tb = t2 - t1;
      printf("\nF2(%d) is %d after %d calculations and %ld seconds\n",
      	num, ret, ncalls, tb);
   }
   return 0;
}

int F1(int i)
{
	ncalls++;	/* increment number of calls */

	if (i < 1) return 0;
   if (i == 1) return 1;
   return F1(i-1) + F1(i-2);
}

int F2(int i)
{
	int t;

   /* we already know the answer, just return it */
   if (knownF[i] != unknown) return knownF[i];

   /* first time calculating this value */
   ncalls++;	/* number of calcuations */

   if (i == 0) t = 0;
   if (i == 1) t = 1;
   if (i > 1) t = F2(i-1) + F2(i-2);
   return knownF[i] = t;
}

