/* prog 5.19 - Constructing a Tournament */
/* this program includes prog 5.18 to print the tree */

#include <stdio.h>
#include <stdlib.h>

#define MAXENT 100

typedef int Item;
typedef struct node *link;
struct node {	/* node structure */
	Item item;	/* max value */
   link l;		/* pointer to left child */
   link r;		/* pointer to right child */
};

/* function prototypes */
link NEW(Item item, link l, link r);
link Max(Item a[], int l, int r);
void printnode(int v, int h);
void show(link x, int h);

int main()
{
	int tbl[MAXENT], nent=0, num;
   char buf[BUFSIZ];
   link ret;

   while (nent < MAXENT)
   {
   	printf("Enter number or ENTER to quit: ");
      gets(buf);
      if (*buf == '\0') break;
      num = atoi(buf);
      tbl[nent++] = num;
   }

   printf("%d numbers entered.\n", nent);
   printf("Press ENTER to build tournament: ");
   gets(buf);

   ret = Max(tbl, 0, nent-1);
   printf("Max is %d\n", ret->item);
   printf("Press ENTER to see the tree: ");
   gets(buf);
   show(ret, 0);	/* display tree */
   printf("Press ENTER to terminate program: ");
   gets(buf);

   return 0;
}

link NEW(Item item, link l, link r)
{
	link x;

   /* create node and initialize it */
   x = (link)malloc(sizeof *x);
   x->item = item;	/* actual data */
   x->l = l;			/* left node */
   x->r = r;			/* right node */

   return x;	/* return node */
}

/* construct node w/ largest value from subtree */
link Max(Item a[], int l, int r)
{
	int m;
   Item u, v;
   link x;

   m = (l+r)/2;	/* calculate modpoint */
   x = NEW(a[m], NULL, NULL);	/* create node for max */

   /* if only one node, return this node */
   if (l == r) return x;

   /* node is root of subtree - create children */
   x->l = Max(a, l, m);	/* left subtree */
   x->r = Max(a, m+1, r); /* right subtree */

   /* place largest value from left & right subtree in node */
   u = x->l->item;	/* max value of left subtree */
   v = x->r->item;	/* max value of right subtree */
   /* place the largest value into this node (x) */
   if (u > v) x->item = u;	/* left larger */
   else x->item = v;			/* right larger */

   /* node constructed - return node w/ max value */
   return x;
}

/* following routines are fromprogram 5.18 */
void printnode(int v, int h)
{
	int i;

   printf("[%2d] ", h);	/* print depth of tree */
   /* now print 2 spaces for each level above this node */
   for (i = 0; i < h; i++) printf("  ");
   /* finally, print this node */
   printf("%2d\n", v);
}

void show(link x, int h)
{
	/* print asterisk for empty nodes */
	if (x == NULL)
   {  /******* don't print anything
   	printnode(0, h); /* zero indicates empty (available) node */
      return;
   }

	/* now, display this node: right, node, left */
   show(x->r, h+1);			/* show the right subtree */
   printnode(x->item, h);	/* print this node */
   show(x->l, h+1);			/* print left subtree */
}

