/* prog 5.4 - Recursive Prefix Evaluator */

#include <stdio.h>
#include <stdlib.h>

/* global variables used by eval() */
char a[BUFSIZ]; /* string to evaluate */
int i;			/* current position within string */
int ncalls=0;	/* number recursive calls */
int calldepth=0, maxdepth=0;

int eval(void);	/* evaluation function */
void print_line(void);
int main()
{
	int x;

	do
   {
   	printf("Enter string to evaluate: ");
      gets(a);	/* get string from user */
      ncalls = i = 0;	/* start of string */
      x = eval();	/* evaluate string */
		printf("eval() returned %d after %d calls, maxdepth=%d\n", x, ncalls, maxdepth);
      printf("Again? (y or n): ");
      gets(a);
   } while (*a != 'n');
   return 0;
}

int eval()
{
	int x = 0;

   calldepth++;	/* increase call depth */
   print_line(); /* report progress */

   /* ignore leading spaces */
   while (a[i] == ' ') i++;

   /*
    * we are at a non-blank
    * we examine the next character
    * if a plus, we add the next two values
    * if an asterisk, we multiply the next two values
    * if a digit, it is the start of a number
    */
   if (a[i] == '+')
   { /* addition - add next two values */
   	i++;	/* skip past + sign */
      x = eval() + eval(); /* return sum */
      calldepth--;	/* exiting function */
      return x;
   }

   if (a[i] == '*')
   { /* multiplication */
   	i++;
      x = eval() * eval();
      calldepth--;
      return x;
   }

   /*
    * should be start of a number
    * initialize x to 0
    * then keep shifting & adding the next digit
    *
    * Notice that if invalid characters are present,
    * this routine doesn't handle them
    */
    while ((a[i] >= '0') && (a[i] <= '9'))
    {
    	x = 10*x + (a[i++]-'0');
    }
    calldepth--;	/* exiting routine */
    return x;
}

void
print_line(void)
{
	char buf[BUFSIZ];

   if (calldepth > maxdepth) maxdepth = calldepth;
	printf("[depth %d] eval(%s)\n", calldepth, a+i);
   if (++ncalls % 25 == 24)
   {
   	printf("Press ENTER to continue: ");
      gets(buf);
   }
}
