/* Prog 5.7 - Tower of Hanoi */
#include <stdio.h>
#include <stdlib.h>

void hanoi(int N, int d);
void shift(int n, int d);
void print_line(char *s);

int nmoves = 0, verbose=0;

int main()
{
	char buf[BUFSIZ];
   int n;

   do
   {
   	printf("Enter number of disks: ");
      gets(buf);
      n = atoi(buf);
      printf("Verbose? (y or n): ");
      gets(buf);
      verbose = (buf[0] == 'y');
      nmoves = 0;
		hanoi(n, +1);
      printf("\n%d moves total\n", nmoves);
      printf("Again? (y or n): ");
      gets(buf);
   } while (buf[0] != 'n');

   return 0;
}

void hanoi(int N, int d)
{
	char buf[BUFSIZ];

   if (verbose) printf(" hanoi(%d,%d)", N, d);

   if (N == 0) return;
   hanoi(N-1, -d);
   shift(N, d);
   hanoi(N-1, -d);
}

void shift(int n, int d)
{
	char buf[BUFSIZ];

   sprintf(buf, "shift(%d,%d)", n, d);
   print_line(buf);
}

void print_line(char *s)
{
	char buf[BUFSIZ];

   if (nmoves % 25 == 24)
   {
   	printf("\nPress ENTER to continue: ");
      gets(buf);
   }
	printf("\n%3d %s", ++nmoves, s);
}
