/* prog 6.3 - Insertion Sort */

#include <stdio.h>
#include <stdlib.h>

#include "sort.h"

/*
 * insertion sort
 *
 * bubble smallest entry to first position
 * loop thru rest of array
 * remove current entry
 * shift smaller entries up one position
 * insert current entry before the first larger one
 */
int insertion(Item a[], int l, int r)
{
	int i, j, ret=0;
   Item v;

   /* bubble the smallest entry to the top */
   for (i = l+1; i <= r; i++)
   { /* start at bottom & loop to top */
   	ret++;
   	compexch(a[l], a[i]);
   }

   /* at this point, the smallest entry is at the top */
   for (i = l+2; i <= r; i++)
   { /* loop thru rest of array */
   	j = i;	/* save location of current entry */
      v = a[i]; /* save value of current entry */

      /*
       * now shift all lager entries before current
       * up one position
       */
      while (less(v, a[j-1]))
      { /* entry j larger than entry i - move down */
      	ret++;	/* another swap */
      	a[j] = a[j-1]; /*move down one position */
         j--; /* check previous entry */
      }
      a[j] = v; /* found smaller entry - insert after it */
   }
   return ret;
}

#ifndef SORT
int sort(Item a[], int l, int r)
{
   return insertion(a, l, r);
}
#endif

