/* prog 6.5 - shell sort */

#include <stdio.h>
#include <stdlib.h>

#include "sort.h"

/*
 * Shell Sort
 *
 * Divide collection up into N interleaved pieces
 * sort each piece
 * Reduce N and repeat
 * Continue until N = 1, then terminate
 */
int shellsort(Item a[], int l, int r)
{
	int i, j, h, ret=0;

   /* calculate upper limit for interleave */
   for (h = 1; h <= (r-l)/9; h = 3*h+1) ;

   /*
    * h is the interleave interval
    * Each time through the loop,
    * it is reduced by a third
    */
   for ( ; h > 0; h /= 3)
   { /* i is the second entry of each interleaved piece */
   	for (i = l+h; i <= r; i++)
      { /* insertion sort entry i */
      	int j;
         Item v;

         /* remove entry i from array & save it */
         j = i;	/* entry to examine */
         v = a[i];	/* save entry i */

         /*
          * insertion sort entry i
          * compare entry i with previous entry
          * move smaller entries up until a larger one found
          */
         while (j >= l+h && less(v, a[j-h]))
         { /* entry larger than current - move up */
         	ret++;	/* swapping entries */
         	a[j] = a[j-h];	/* move entry */
            j -= h;	/* next entry to check */
         }
         ret++;	/* another swap */
         a[j] = v; /* insert saved entry in correct position */
      }
   }
   return ret;
}

#ifndef SORT
int sort(Item a[], int l, int r)
{
	return shellsort(a, l, r);
}
#endif

